#ifndef __IVFEXAMVWR_H__
#define __IVFEXAMVWR_H__

#include <Ivf/IvfVwr.h>

class SoSceneViewer ;

class CIvfSceneViewer : public CIvfVwr
{
public:
	CIvfSceneViewer() ;
	DECLARE_DYNCREATE(CIvfSceneViewer) ;
	
	~CIvfSceneViewer() ;

	virtual void 			CreateViewer(void *pVwrArgs);

	virtual void			DestroyViewer() ;
	virtual void			SceneGraphChanged() ;

	virtual BOOL			OnUpdateFrameTitle(CString &strTitle) ;
	virtual void			OnPaint() ;
	virtual void			OnInitialUpdate() ;
	virtual void			OnDeactivateView() ;
	virtual void			OnActivateView() ;
	virtual void			OnDestroy() ;
	virtual BOOL			OnCommand(WPARAM wParam, LPARAM lParam);
	virtual BOOL			PreTranslateMessage(MSG *pMsg) ;
	virtual SoWinComponent *GetVwrComponent() ;

	static void 			GetRuntimeClass(CRuntimeClass &classInfo);

	void					DeleteContents() ;

protected:
	BOOL 					UpdateWindowText();

	void 					FindLightMenuPos(HMENU hTopMenu = NULL) ;
	void 					FindTopWindow() ;
	void 					DrawTopMenuBar() ;

	SoSceneViewer *			m_pViewer;
	HMENU 					m_hLightMenu ;
	HMENU 					m_hPrevLightMenu ;
	HMENU 					m_hTopMenu ;
	CMenu *					m_pTopMenu ;
	int 					m_nLightMenuPos ;
	CString 				m_strTitle ;
	CWnd *					m_pTopWnd ;

public:
	 void OnFileInfo();
	 void OnUpdateFileInfo(CCmdUI* pCmdUI);
	 void OnFileImport();
	 void OnUpdateFileImport(CCmdUI* pCmdUI);
	 void OnViewScreendoortransparency();
	 void OnUpdateViewScreendoortransparency(CCmdUI* pCmdUI);
	 void OnViewBlendedtransparency();
	 void OnUpdateViewBlendedtransparency(CCmdUI* pCmdUI);
	 void OnViewDelayedblendedtransparency();
	 void OnUpdateViewDelayedblendedtransparency(CCmdUI* pCmdUI);
	 void OnViewSortedblendedtransparency();
	 void OnUpdateViewSortedblendedtransparency(CCmdUI* pCmdUI);
	 void OnViewViewselection();
	 void OnUpdateViewViewselection(CCmdUI* pCmdUI);
	 void OnViewFog();
	 void OnUpdateViewFog(CCmdUI* pCmdUI);
	 void OnViewAntialiasing();
	 void OnUpdateViewAntialiasing(CCmdUI* pCmdUI);
	 void OnViewEditbackgroundcolor();
	 void OnUpdateViewEditbackgroundcolor(CCmdUI* pCmdUI);
	 void OnUpdateViewExaminer(CCmdUI* pCmdUI);
	 void OnViewExaminer();
	 void OnViewFly();
	 void OnUpdateViewFly(CCmdUI* pCmdUI);
	 void OnViewPlane();
	 void OnUpdateViewPlane(CCmdUI* pCmdUI);
	 void OnViewWalk();
	 void OnUpdateViewWalk(CCmdUI* pCmdUI);
	 void OnViewPicedit();
	 void OnUpdateViewPicedit(CCmdUI* pCmdUI);
	 void OnSelectionShiftselection();
	 void OnUpdateSelectionShiftselection(CCmdUI* pCmdUI);
	 void OnSelectionSingleselection();
	 void OnUpdateSelectionSingleselection(CCmdUI* pCmdUI);
	 void OnSelectionToggleselection();
	 void OnUpdateSelectionToggleselection(CCmdUI* pCmdUI);
	 void OnEditorsColoreditor();
	 void OnUpdateEditorsColoreditor(CCmdUI* pCmdUI);
	 void OnEditorsMaterialeditor();
	 void OnUpdateEditorsMaterialeditor(CCmdUI* pCmdUI);
	 void OnEditorsTransformsliders();
	 void OnUpdateEditorsTransformsliders(CCmdUI* pCmdUI);
	 void OnManipsCenterball();
	 void OnUpdateManipsCenterball(CCmdUI* pCmdUI);
	 void OnManipsHandlebox();
	 void OnUpdateManipsHandlebox(CCmdUI* pCmdUI);
	 void OnManipsJack();
	 void OnUpdateManipsJack(CCmdUI* pCmdUI);
	 void OnManipsNone();
	 void OnUpdateManipsNone(CCmdUI* pCmdUI);
	 void OnManipsReplace();
	 void OnUpdateManipsReplace(CCmdUI* pCmdUI);
	 void OnManipsTabbox();
	 void OnUpdateManipsTabbox(CCmdUI* pCmdUI);
	 void OnManipsTrackball();
	 void OnUpdateManipsTrackball(CCmdUI* pCmdUI);
	 void OnManipsTransformbox();
	 void OnUpdateManipsTransformbox(CCmdUI* pCmdUI);
	 void OnLightsCreatedirlight();
	 void OnUpdateLightsCreatedirlight(CCmdUI* pCmdUI);
	 void OnLightsCreatepointlight();
	 void OnUpdateLightsCreatepointlight(CCmdUI* pCmdUI);
	 void OnLightsCreatespotlight();
	 void OnUpdateLightsCreatespotlight(CCmdUI* pCmdUI);
	 void OnUpdateLightsHideallicons(CCmdUI* pCmdUI);
	 void OnLightsHideallicons();
	 void OnLightsAmbientlighting();
	 void OnUpdateLightsAmbientlighting(CCmdUI* pCmdUI);
	 void OnLightsShowallicons();
	 void OnUpdateLightsShowallicons(CCmdUI* pCmdUI);
	 void OnLightsTurnalloff();
	 void OnUpdateLightsTurnalloff(CCmdUI* pCmdUI);
	 void OnLightsTurnallon();
	 void OnUpdateLightsTurnallon(CCmdUI* pCmdUI);
	 void OnUpdateFilePrint(CCmdUI* pCmdUI);
	 void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	 void OnUpdateFilePrintSetup(CCmdUI* pCmdUI);
	 void OnUpdateEditCopy(CCmdUI* pCmdUI);
	 void OnUpdateEditCut(CCmdUI* pCmdUI);
	 void OnUpdateEditPaste(CCmdUI* pCmdUI);
	 void OnUpdateEditUndo(CCmdUI* pCmdUI);
} ;


#endif
